function varargout = APxControl(varargin)
% APXCONTROL MATLAB code for APxControl.fig
%      APXCONTROL, by itself, creates a new APXCONTROL or raises the existing
%      singleton*.
%
%      H = APXCONTROL returns the handle to a new APXCONTROL or the handle to
%      the existing singleton*.
%
%      APXCONTROL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in APXCONTROL.M with the given input arguments.
%
%      APXCONTROL('Property','Value',...) creates a new APXCONTROL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before APxControl_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to APxControl_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help APxControl

% Last Modified by GUIDE v2.5 18-Dec-2015 14:26:28

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @APxControl_OpeningFcn, ...
                   'gui_OutputFcn',  @APxControl_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% Add reference to the API wrapper.
apiRoot = 'C:\Program Files (x86)\Audio Precision\APx500 4.4\API\';
NET.addAssembly([apiRoot 'AudioPrecision.API2.dll']);
    
% End initialization code - DO NOT EDIT


% --- Executes just before APxControl is made visible.
function APxControl_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to APxControl (see VARARGIN)

% Choose default command line output for APxControl
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes APxControl wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = APxControl_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
clc
    % Create an instance of the application, and make it visible.
    APx = AudioPrecision.API.APx500_Application;
    APx.Visible = true;
    

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
clc
    % Create an instance of the application, and make it visible.
    APx = AudioPrecision.API.APx500_Application(AudioPrecision.API.APxOperatingMode.SequenceMode);    
    
    filename = 'SampleProject.approjx';
    directory = pwd;
    fullpath = [directory, '\', filename];

    APx.OpenProject(fullpath);
    APx.Sequence.Run();

    %Get Settled results from Level and Gain measurement
    measurement = APx.Sequence.Item('Signal Path1').Item('Level and Gain')
    
    %Check to ensure settled results are available    
    if measurement.HasSequenceResults
        %Get the object for the Level and Gain sequence results
        Results = measurement.SequenceResults
        
        %Get the meter readings
        %RMS Level        
        RMSLevelValues = double(Results.Item(AudioPrecision.API.MeasurementResultType.LevelMeter).GetMeterValues())

        %Gain
        GainValues = double(Results.Item(AudioPrecision.API.MeasurementResultType.GainMeter).GetMeterValues())

        %Peak Level
        PeakLevelValues = double(Results.Item(AudioPrecision.API.MeasurementResultType.PeakLevelMeter).GetMeterValues())
    end
 
    %Get X/Y values from Stepped Frequency Sweep
    measurement = APx.Sequence.Item('Signal Path1').Item('Stepped Frequency Sweep')
    
    %Check to ensure results are available
    if measurement.HasSequenceResults
        Results = measurement.SequenceResults
        
        %RMS Level
        LevelVsFrequencyXYResults = Results.Item(AudioPrecision.API.MeasurementResultType.LevelVsFrequency)
        
        RMSLevelXAxis_Data = double(LevelVsFrequencyXYResults.GetXValues(AudioPrecision.API.InputChannelIndex.Ch1, AudioPrecision.API.VerticalAxis.Left, AudioPrecision.API.SourceDataType.Measured, 1))
        RMSLevelYAxis_Ch1_LevelData = double(LevelVsFrequencyXYResults.GetYValues(AudioPrecision.API.InputChannelIndex.Ch1, AudioPrecision.API.VerticalAxis.Left, AudioPrecision.API.SourceDataType.Measured, 1))
        RMSLevelYAxis_Ch2_LevelData = double(LevelVsFrequencyXYResults.GetYValues(AudioPrecision.API.InputChannelIndex.Ch2, AudioPrecision.API.VerticalAxis.Left, AudioPrecision.API.SourceDataType.Measured, 1))

        %RMS Level Smoothed Derived Result
        SmoothedXYResults = Results.Item('RMS Level -> Smooth')
        
        SmoothXValues = double(SmoothedXYResults.GetXValues(AudioPrecision.API.InputChannelIndex.Ch1, AudioPrecision.API.VerticalAxis.Left, AudioPrecision.API.SourceDataType.Measured, 1))
        SmoothYValues_Ch1 = double(SmoothedXYResults.GetYValues(AudioPrecision.API.InputChannelIndex.Ch1, AudioPrecision.API.VerticalAxis.Left, AudioPrecision.API.SourceDataType.Measured, 1))
        SmoothYValues_Ch2 = double(SmoothedXYResults.GetYValues(AudioPrecision.API.InputChannelIndex.Ch2, AudioPrecision.API.VerticalAxis.Left, AudioPrecision.API.SourceDataType.Measured, 1))
        
        %DeviationResults
        DeviationResults = Results.Item('Deviation (20.0000 Hz - 20.0000 kHz)')
        DeviationValues = double(DeviationResults.GetMeterValues())
        
        %Alternate approach using For statement to get the data
        ItemCount = int16(APx.Sequence.Item('Signal Path1').Item('Stepped Frequency Sweep').SequenceResults.Count) - 1;
        
        for ResultIndex = 0:1:ItemCount
            %RMS Level
            NameString = char(APx.Sequence.Item('Signal Path1').Item('Stepped Frequency Sweep').SequenceResults.Item(ResultIndex).Name);
            if strcmp(NameString, 'RMS Level')
                RMSLevelXAxis_Data = double(LevelVsFrequencyXYResults.GetXValues(AudioPrecision.API.InputChannelIndex.Ch1, AudioPrecision.API.VerticalAxis.Left, AudioPrecision.API.SourceDataType.Measured, 1))
                RMSLevelYAxis_Ch1_LevelData = double(LevelVsFrequencyXYResults.GetYValues(AudioPrecision.API.InputChannelIndex.Ch1, AudioPrecision.API.VerticalAxis.Left, AudioPrecision.API.SourceDataType.Measured, 1))
                RMSLevelYAxis_Ch2_LevelData = double(LevelVsFrequencyXYResults.GetYValues(AudioPrecision.API.InputChannelIndex.Ch2, AudioPrecision.API.VerticalAxis.Left, AudioPrecision.API.SourceDataType.Measured, 1))
            end
            %RMS Level -> Smooth
            if strcmp(NameString, 'RMS Level -> Smooth')
                SmoothXValues = double(SmoothedXYResults.GetXValues(AudioPrecision.API.InputChannelIndex.Ch1, AudioPrecision.API.VerticalAxis.Left, AudioPrecision.API.SourceDataType.Measured, 1))
                SmoothYValues_Ch1 = double(SmoothedXYResults.GetYValues(AudioPrecision.API.InputChannelIndex.Ch1, AudioPrecision.API.VerticalAxis.Left, AudioPrecision.API.SourceDataType.Measured, 1))
                SmoothYValues_Ch2 = double(SmoothedXYResults.GetYValues(AudioPrecision.API.InputChannelIndex.Ch2, AudioPrecision.API.VerticalAxis.Left, AudioPrecision.API.SourceDataType.Measured, 1))
            end
            %Deviation
            if strcmp(NameString, 'Deviation (20.0000 Hz - 20.0000 kHz)')
                DeviationValues = double(DeviationResults.GetMeterValues())
            end
        end
    end
    
%--- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
clc
    % Create an instance of the application, and make it visible.
    APx = AudioPrecision.API.APx500_Application(AudioPrecision.API.APxOperatingMode.BenchMode);

    %Configure Signal Path Setup Input/Output
    disp('Configure Signal Path Setup Input/Output')
    APx.BenchMode.Setup.OutputConnector.Type = AudioPrecision.API.OutputConnectorType.AnalogBalanced;
    APx.BenchMode.Setup.AnalogOutput.ChannelCount = 2;
    APx.BenchMode.Setup.AnalogOutput.BalancedSourceImpedance = AudioPrecision.API.AnalogBalancedSourceImpedance.SourceImpedance_40;

    APx.BenchMode.Setup.InputConnector.Type = AudioPrecision.API.InputConnectorType.AnalogBalanced;
    APx.BenchMode.Setup.AnalogInput.ChannelCount = 2;
    APx.BenchMode.Setup.AnalogInput.SetTermination(AudioPrecision.API.InputChannelIndex.Ch1, AudioPrecision.API.AnalogInputTermination.InputTermination_Bal_200k);
    APx.BenchMode.Setup.AnalogInput.UseHighPerformanceSineAnalyzer = true;

    %Configure Signal Path Setup Filters
    disp('Configure Signal Path Setup Filters')
    APx.BenchMode.Setup.HighpassFilter = AudioPrecision.API.HighpassFilterMode.DC;
    APx.BenchMode.Setup.LowpassFilterAnalog = AudioPrecision.API.LowpassFilterModeAnalog.Elliptic;
    APx.BenchMode.Setup.LowpassFilterFrequencyAnalog = 20000;
    APx.BenchMode.Setup.LowpassFilterAnalogBandwidth = AudioPrecision.API.AdcBandwidth.bw90k;
    APx.BenchMode.Setup.WeightingFilter = AudioPrecision.API.SignalPathWeightingFilterType.wt_None;
    APx.BenchMode.Setup.DeviceDelay.Value = 0;

    %Configure Generator
    disp('Configure Generator')
    APx.BenchMode.Generator.AutoOn = false;
    APx.BenchMode.Generator.AnalogSineMode = AudioPrecision.API.AnalogSineGeneratorMode.HighPerformanceSineGenerator;
    APx.BenchMode.Generator.Levels.SetValue(AudioPrecision.API.OutputChannelIndex.Ch1, 1.0);
    APx.BenchMode.Generator.Frequency.Value = 2000;
    APx.BenchMode.Generator.On = true;

    %Configure Analyzer
    disp('Configure Analyzer')
    APx.BenchMode.Analyzer.BandpassFilterTuning = AudioPrecision.API.FilterTuningType.GeneratorFrequency;
    APx.BenchMode.Analyzer.ThdNWeighting = AudioPrecision.API.SignalPathWeightingFilterType.wt_None;
    APx.BenchMode.Analyzer.BandpassFilterTuning = AudioPrecision.API.FilterTuningType.GeneratorFrequency;
    APx.BenchMode.Analyzer.ReferenceChannel = AudioPrecision.API.InputChannelIndex.Ch1;
    APx.BenchMode.Analyzer.ImdMeterType = AudioPrecision.API.ImdAnalysisType.SmpteDin;

    %Monitors/Meters
    %Add required Monitors/Meters
    APx.BenchMode.Meters.Show()
    APx.BenchMode.Meters.Enabled = false;

    %Delete current Monitors/Meters  
    disp('Delete current Monitors/Meters')
    MeterCount = APx.BenchMode.Meters.Count;
    for meterIndex = MeterCount - 1: -1: 0;
        APx.BenchMode.Meters.Remove((meterIndex))
    end
    
    %Add desired Monitors/Meters
    disp('Add desired Monitors/Meters')
    APx.BenchMode.Meters.Add(AudioPrecision.API.BenchModeMeterType.BandpassLevelMeter);
    APx.BenchMode.Meters.Add(AudioPrecision.API.BenchModeMeterType.DcLevelMeter);
    APx.BenchMode.Meters.Add(AudioPrecision.API.BenchModeMeterType.GainMeter);
    APx.BenchMode.Meters.Add(AudioPrecision.API.BenchModeMeterType.ThdNRatioMeter);

    %Configure settling for desired Monitors/Meters
    disp('Configure settling for desired Monitors/Meters')
    APx.BenchMode.Analyzer.Settling.Enabled = true;
    APx.BenchMode.Analyzer.Settling.ReadingTimeout = 5;
    APx.BenchMode.Analyzer.Settling.TrackFirst = true;

    APx.BenchMode.Analyzer.Settling.Item(AudioPrecision.API.SettlingMeterType.RmsLevel).ResetToDefaults

    APx.BenchMode.Analyzer.Settling.Item(AudioPrecision.API.SettlingMeterType.BandpassLevel).Item(AudioPrecision.API.InputChannelIndex.Ch1).Algorithm = AudioPrecision.API.SettlingAlgorithmEx.Average;

    ChannelSettlingParameters = APx.BenchMode.Analyzer.Settling.Item(AudioPrecision.API.SettlingMeterType.BandpassLevel).Item(AudioPrecision.API.InputChannelIndex.Ch1);
    ChannelSettlingParameters.Algorithm = AudioPrecision.API.SettlingAlgorithmEx.None;
    ChannelSettlingParameters.DelayTime = 0.031;
    ChannelSettlingParameters.DelayCycles = 4;
    ChannelSettlingParameters.SettlingTime = 0.251;
    ChannelSettlingParameters.SettlingCycles = 4;
    ChannelSettlingParameters.Points = 4;
    ChannelSettlingParameters.Tolerance = 4;
    ChannelSettlingParameters.Floor = 0.00000002;

    APx.BenchMode.Analyzer.Settling.ResetToDefaults()

    APx.BenchMode.Meters.Enabled = true;
    
    %Get Settled readings from meters all at the same time.    
    %Create an array of settling meter types
    SettledMeterTypes = NET.createArray('AudioPrecision.API.SettlingMeterType', 4);
    SettledMeterTypes(1) = AudioPrecision.API.SettlingMeterType.BandpassLevel;
    SettledMeterTypes(2) = AudioPrecision.API.SettlingMeterType.DcLevel;
    SettledMeterTypes(3) = AudioPrecision.API.SettlingMeterType.Gain;
    SettledMeterTypes(4) = AudioPrecision.API.SettlingMeterType.ThdNRatio;
    
    %Pass the array of meter types to get the ISettledResultCollection 
    MeterReadings = APx.BenchMode.GetSettledMeterReadings(SettledMeterTypes);
    %Get readings for each meter type
    BandpassValues = double(MeterReadings.Item(AudioPrecision.API.SettlingMeterType.BandpassLevel).GetValues('Vrms'))
    DCLevelValues = double(MeterReadings.Item(AudioPrecision.API.SettlingMeterType.DcLevel).GetValues('V'))
    GainValues = double(MeterReadings.Item(AudioPrecision.API.SettlingMeterType.Gain).GetValues('dB'))
    ThdNValues = double(MeterReadings.Item(AudioPrecision.API.SettlingMeterType.ThdNRatio).GetValues('dB'))

    %Get Settled readings from meters one at a time.
    SettledMeterTypes = NET.createArray('AudioPrecision.API.SettlingMeterType', 1);
    SettledMeterTypes(1) = AudioPrecision.API.SettlingMeterType.BandpassLevel;
    MeterReadings = APx.BenchMode.GetSettledMeterReadings(SettledMeterTypes);
    BandpassValues = double(MeterReadings.Item(0).GetValues('Vrms'))
    
    SettledMeterTypes(1) = AudioPrecision.API.SettlingMeterType.DcLevel;
    MeterReadings = APx.BenchMode.GetSettledMeterReadings(SettledMeterTypes);
    DCLevelValues = double(MeterReadings.Item(0).GetValues('V'))

    SettledMeterTypes(1) = AudioPrecision.API.SettlingMeterType.Gain;
    MeterReadings = APx.BenchMode.GetSettledMeterReadings(SettledMeterTypes);
    GainValues = double(MeterReadings.Item(0).GetValues('dB'))
    
    SettledMeterTypes(1) = AudioPrecision.API.SettlingMeterType.ThdNRatio;
    MeterReadings = APx.BenchMode.GetSettledMeterReadings(SettledMeterTypes);
    ThdNValues = double(MeterReadings.Item(0).GetValues('dB'))
    
    %Sweep measurement
    %Configure measurement settings
    disp('Configure measurement settings')
    APx.BenchMode.Measurements.SteppedSweep.Show()
    APx.BenchMode.Measurements.SteppedSweep.Repeat = false;
    APx.BenchMode.Measurements.SteppedSweep.Append = false;
    APx.BenchMode.Measurements.SteppedSweep.Source = AudioPrecision.API.SweepSourceParameterType.GeneratorFrequency;
    APx.BenchMode.Measurements.SteppedSweep.SourceParameters.Start.Unit = 'Hz';
    APx.BenchMode.Measurements.SteppedSweep.SourceParameters.Start.Value = 20;
    APx.BenchMode.Measurements.SteppedSweep.SourceParameters.Stop.Value = 20000;
    APx.BenchMode.Measurements.SteppedSweep.SourceParameters.StepType = AudioPrecision.API.SweepStepType.Log;
    APx.BenchMode.Measurements.SteppedSweep.SourceParameters.NumberOfPoints = 31;

    %Set Right axis data to THD+N Ratio
    disp('Set Right axis data to THD+N Ratio')
    APx.BenchMode.SignalPathSettingsVisible = false;
    APx.BenchMode.GeneratorAnalyzerSettingsVisible = false;

    APx.BenchMode.Measurements.SteppedSweep.Graphs.Item(0).Result.AsXYGraph().DefineRightAxisResult(AudioPrecision.API.MeasurementResultType.ThdNRatioVsFrequency)

    APx.BenchMode.Measurements.SteppedSweep.ReadingRate = AudioPrecision.API.SweepReadingRate.ReadingRate_32;
    APx.BenchMode.Measurements.SteppedSweep.PreSweepDelay = 0.3;

    APx.BenchMode.Measurements.SteppedSweep.NestedSweep.Source = AudioPrecision.API.NestedSweepParameterType.GeneratorLevel;
    APx.BenchMode.Measurements.SteppedSweep.NestedSweep.SourceParameters.Start.Value = 1;
    APx.BenchMode.Measurements.SteppedSweep.NestedSweep.SourceParameters.Stop.Value = 2;
    APx.BenchMode.Measurements.SteppedSweep.NestedSweep.SourceParameters.StepType = AudioPrecision.API.SweepStepType.Lin;
    APx.BenchMode.Measurements.SteppedSweep.NestedSweep.SourceParameters.NumberOfPoints = 2;

    APx.BenchMode.Measurements.SteppedSweep.Start()
    disp('Start Stepped Sweep measurement')
        
    %Wait for Sweep to finish
    pause on
    while APx.BenchMode.Measurements.SteppedSweep.IsStarted;
        fprintf('%s%s\n','.')
        pause(1)
    end
    pause off
    disp('.')
    
    %Get Sweep data from the two Sweeps
    %Get X values from Sweep 1
    SweepXAxisValues = double(APx.BenchMode.Measurements.SteppedSweep.Graphs.Item('RMS Level').Result.AsXYGraph().GetXValues(AudioPrecision.API.InputChannelIndex.Ch1, 0, 'Hz', AudioPrecision.API.VerticalAxis.Left))
    %Get Y values from Sweep 1
    SweepAcq1YAxis_LevelValues = double(APx.BenchMode.Measurements.SteppedSweep.Graphs.Item('RMS Level').Result.AsXYGraph().GetYValues(AudioPrecision.API.InputChannelIndex.Ch1, 0, 'Vrms', AudioPrecision.API.VerticalAxis.Left))
    SweepAcq1YAxis_THDNValues = double(APx.BenchMode.Measurements.SteppedSweep.Graphs.Item('RMS Level').Result.AsXYGraph().GetYValues(AudioPrecision.API.InputChannelIndex.Ch1, 0, 'dB', AudioPrecision.API.VerticalAxis.Right))
    %Get Y values from Sweep 2
    SweepAcq2YAxis_LevelValues = double(APx.BenchMode.Measurements.SteppedSweep.Graphs.Item('RMS Level').Result.AsXYGraph().GetYValues(AudioPrecision.API.InputChannelIndex.Ch1, 1, 'Vrms', AudioPrecision.API.VerticalAxis.Left))
    SweepAcq2YAxis_THDNValues = double(APx.BenchMode.Measurements.SteppedSweep.Graphs.Item('RMS Level').Result.AsXYGraph().GetYValues(AudioPrecision.API.InputChannelIndex.Ch1, 1, 'dB', AudioPrecision.API.VerticalAxis.Right))

    %FFT measurement
    %Configure measurement settings
    disp('Configure FFT measurement settings')
    APx.BenchMode.Measurements.Fft.Show()
    APx.BenchMode.Measurements.Fft.Repeat = false;
    APx.BenchMode.Measurements.Fft.Append = false;
    APx.BenchMode.Measurements.Fft.AcquisitionType = AudioPrecision.API.AcqLengthType.Auto;
    APx.BenchMode.Measurements.Fft.FFTLength = AudioPrecision.API.FFTLength.FFT_96000;
    APx.BenchMode.Measurements.Fft.WindowType = AudioPrecision.API.WindowType.BlackmanHarris;
    APx.BenchMode.Measurements.Fft.TriggerType = AudioPrecision.API.TriggerType.PositiveZeroCrossing;
    APx.BenchMode.Measurements.Fft.TriggerChannel = AudioPrecision.API.InputChannelIndex.Ch1;
    APx.BenchMode.Measurements.Fft.AveragingType = AudioPrecision.API.AveragingType.Power;
    APx.BenchMode.Measurements.Fft.Averages = 8;
    APx.BenchMode.Measurements.Fft.DelayTimeInSeconds = 0.1;

    APx.BenchMode.Measurements.Fft.Start()
    disp('Start FFT measurement')

    %Wait for FFT to finish
    pause on
    while APx.BenchMode.Measurements.Fft.IsStarted;
        fprintf('%s%s\n','.')
        pause(1)
    end
    pause off
    disp('.')
        
    %Get all FFT data
    FFTXAxisValues = double(APx.BenchMode.Measurements.Fft.Graphs.Item('FFT Spectrum').Result.AsXYGraph().GetAllXValues(AudioPrecision.API.InputChannelIndex.Ch1, 'Hz', AudioPrecision.API.VerticalAxis.Left))
    FFTYAxis_Ch1_LevelValues = double(APx.BenchMode.Measurements.Fft.Graphs.Item('FFT Spectrum').Result.AsXYGraph().GetAllYValues(AudioPrecision.API.InputChannelIndex.Ch1, 'Vrms', AudioPrecision.API.VerticalAxis.Left))
    FFTYAxis_Ch2_LevelValues = double(APx.BenchMode.Measurements.Fft.Graphs.Item('FFT Spectrum').Result.AsXYGraph().GetAllYValues(AudioPrecision.API.InputChannelIndex.Ch2, 'Vrms', AudioPrecision.API.VerticalAxis.Left))
         
    %Get all Scope data
    ScopeXAxisValues = double(APx.BenchMode.Measurements.Fft.Graphs.Item('Scope').Result.AsXYGraph().GetAllXValues(AudioPrecision.API.InputChannelIndex.Ch1, 's', AudioPrecision.API.VerticalAxis.Left))
    ScopeYAxis_Ch1_LevelValues = double(APx.BenchMode.Measurements.Fft.Graphs.Item('Scope').Result.AsXYGraph().GetAllYValues(AudioPrecision.API.InputChannelIndex.Ch1, 'V', AudioPrecision.API.VerticalAxis.Left))
    ScopeYAxis_Ch2_LevelValues = double(APx.BenchMode.Measurements.Fft.Graphs.Item('Scope').Result.AsXYGraph().GetAllYValues(AudioPrecision.API.InputChannelIndex.Ch2, 'V', AudioPrecision.API.VerticalAxis.Left))
